<?php

class ps_opay
{
    const APP_NAME = 'VirtueMart 1';
    const WIDGET_VERSION = '1.0.3';
    var $classname = "ps_opay";
    var $payment_code = "OPAY";

    /**
     * Returns the "is_writeable" status of the configuration file
     *
     * @param void
     * @returns bool True when the configuration file is writeable, false when not
     */
    function configfile_writeable()
    {
        return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
    }

    /**
     * Returns the "is_readable" status of the configuration file
     *
     * @param void
     * @return bool True when the configuration file is writeable, false when not
     */
    function configfile_readable()
    {
        return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
    }

    /**
     * If module has configuration file
     *
     * @return bool
     */
    function has_configuration()
    {
        return true;
    }

    /**
     * Show all configuration parameters for this payment method
     *
     * @return bool False when the Payment method has no configration
     */
    function show_configuration()
    {
        global $VM_LANG;
        $VM_LANG->load('opay');
        $db = new ps_DB();

        // Read current Configuration
        include_once(CLASSPATH ."payment/".$this->classname.".cfg.php");
    ?>
    <table class="adminform">
        <tr class="row0">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_WEBSITE_ID') ?></strong></td>
            <td>
                <input type="text" name="OPAY_WEBSITE_ID" class="inputbox" value="<?php  echo OPAY_WEBSITE_ID; ?>" />
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_WEBSITE_ID_EXPLAIN') ?></td>
        </tr>
        <tr class="row1">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_TEST_MODE') ?></strong></td>
            <td>
                <select name="OPAY_TEST_MODE" class="inputbox" >
                <option <?php if (@OPAY_TEST_MODE == '1') echo "selected=\"selected\""; ?> value="1"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
                <option <?php if (@OPAY_TEST_MODE != '1') echo "selected=\"selected\""; ?> value="0"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
            <td></td>
        </tr>
        <tr class="row0">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_USER_ID') ?></strong></td>
            <td>
                <input type="text" name="OPAY_USER_ID" class="inputbox" value="<?php echo OPAY_USER_ID; ?>" />
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_USER_ID_EXPLAIN') ?></td>
        </tr>
        <tr class="row1">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_SIGNATURE_TYPE') ?></strong></td>
            <td>
                <select name="OPAY_SIGNATURE_TYPE" class="inputbox" >
                <option <?php if (@OPAY_SIGNATURE_TYPE == '1') echo "selected=\"selected\""; ?> value="1"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_SIGNATURE_PASSWORD_OPTION') ?></option>
                <option <?php if (@OPAY_SIGNATURE_TYPE == '2') echo "selected=\"selected\""; ?> value="2"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_RSA_PRIVATE_KEY_OPTION') ?></option>
                </select>
            </td>
            <td></td>
        </tr>
        <tr class="row0">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_SIGNATURE_PASSWORD') ?></strong></td>
            <td>
                <input type="text" name="OPAY_SIGNATURE_PASSWORD" class="inputbox" value="<?php echo OPAY_SIGNATURE_PASSWORD; ?>" />
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_SIGNATURE_PASSWORD_EXPLAIN') ?></td>
        </tr>
        <tr class="row1">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_RSA_PRIVATE_KEY') ?></strong></td>
            <td>
                <textarea class="inputbox" name="OPAY_RSA_PRIVATE_KEY"><?php echo OPAY_RSA_PRIVATE_KEY; ?></textarea>
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_RSA_PRIVATE_KEY_EXPLAIN') ?></td>
        </tr>
        <tr class="row0">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_OPAY_CERTIFICATE') ?></strong></td>
            <td>
                <textarea class="inputbox" name="OPAY_OPAY_CERTIFICATE"><?php echo OPAY_OPAY_CERTIFICATE; ?></textarea>
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_OPAY_CERTIFICATE_EXPLAIN') ?>
            </td>
        </tr>
        <br>
        <tr class="row1">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_STATUS_SUCCESS') ?></strong></td>
            <td>
                <select name="OPAY_STATUS_SUCCESS" class="inputbox" >
                <?php
                    $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
                    $db->query($q);
                    $order_status_code = Array();
                    $order_status_name = Array();

                    while ($db->next_record()) {
                      $order_status_code[] = $db->f("order_status_code");
                      $order_status_name[] =  $db->f("order_status_name");
                    }
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (OPAY_STATUS_SUCCESS == $order_status_code[$i])
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_STATUS_SUCCESS_EXPLAIN') ?>
            </td>
        </tr>
        <tr class="row0">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_STATUS_PENDING') ?></strong></td>
            <td>
                <select name="OPAY_STATUS_PENDING" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (OPAY_STATUS_PENDING == $order_status_code[$i])
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_STATUS_PENDING_EXPLAIN') ?></td>
        </tr>
        <tr class="row1">
            <td><strong><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_STATUS_CANCEL') ?></strong></td>
            <td>
                <select name="OPAY_STATUS_CANCEL" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (OPAY_STATUS_CANCEL == $order_status_code[$i])
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_OPAY_STATUS_CANCEL_EXPLAIN') ?>
            </td>
        </tr>
      </table>
    <?php

        return true;
    }

    /**
     * Writes the configuration file for this payment method
     *
     * @param array An array of objects
     * @return bool True when writing was successful
     */
    function write_configuration( &$d )
    {
        $extrainfo = <<<EOF
<?php
require_once(CLASSPATH.'payment/ps_opay.php');
ps_opay::extrainfo_redirect();
?>
EOF;
        // Here we set extrainfo so that client couldn't change it in admin
        // panel.
        $d['payment_extrainfo'] = $extrainfo;
        $_POST['payment_extrainfo'] = $extrainfo;

        $config = array(
            'OPAY_WEBSITE_ID'         => isset($d['OPAY_WEBSITE_ID']) ? $d['OPAY_WEBSITE_ID'] : '',
            'OPAY_TEST_MODE'          => isset($d['OPAY_TEST_MODE']) ? $d['OPAY_TEST_MODE'] : '0',
            'OPAY_USER_ID'            => isset($d['OPAY_USER_ID']) ? $d['OPAY_USER_ID'] : '',
            'OPAY_SIGNATURE_TYPE'     => isset($d['OPAY_SIGNATURE_TYPE']) ? $d['OPAY_SIGNATURE_TYPE'] : '1',
            'OPAY_SIGNATURE_PASSWORD' => isset($d['OPAY_SIGNATURE_PASSWORD']) ? $d['OPAY_SIGNATURE_PASSWORD'] : '',
            'OPAY_RSA_PRIVATE_KEY'    => isset($d['OPAY_RSA_PRIVATE_KEY']) ? $d['OPAY_RSA_PRIVATE_KEY'] : '',
            'OPAY_OPAY_CERTIFICATE'   => isset($d['OPAY_OPAY_CERTIFICATE']) ? $d['OPAY_OPAY_CERTIFICATE'] : '',
            'OPAY_STATUS_SUCCESS'     => isset($d['OPAY_STATUS_SUCCESS']) ? $d['OPAY_STATUS_SUCCESS'] : 'C',
            'OPAY_STATUS_PENDING'     => isset($d['OPAY_STATUS_PENDING']) ? $d['OPAY_STATUS_PENDING'] : 'P',
            'OPAY_STATUS_CANCEL'      => isset($d['OPAY_STATUS_CANCEL']) ? $d['OPAY_STATUS_CANCEL'] : 'X',
        );
        $string = "<?php\n";
        $string .= "if (!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to '.basename(__FILE__).' is not allowed.');\n\n";
        foreach( $config as $key => $value ) {
          $string .= "define('$key', '$value');\n";
        }

        if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
            fputs($fp, $string, strlen($string));
            fclose ($fp);
            return true;
        } else {
          return false;
        }
    }

    /**
     * This is the main function for all payment modules that use direct
     * connections to a payment gateway (like authorize.net or eWay XML). This
     * is the place, where the payment details are validated and captured on
     * success. Returns true on sucess, false on failure.
     *
     * We can't redirect client to OPAY side here because order is not created
     * yet.
     *
     * @return bool
     */
    function process_payment($order_number, $order_total, &$d)
    {
        return true;
    }

    /**
     * Function redirects client to opay. This is called when extra info is
     * evaluated at checkout.
     *
     * @return void
     */
    function extrainfo_redirect()
    {
        require_once(CLASSPATH.'opay/opay_8.1.gateway.inc.php');
        require_once(CLASSPATH.'ps_order.php');

        // These come from html/checkout.thankyou.php
        global $VM_LANG, $db, $user;

        $VM_LANG->load('opay');
        $jlang = JFactory::getLanguage();
        $opay = new OpayGateway();

        $db1 = new ps_DB();
        $db1->query("SELECT country_2_code FROM #__{vm}_country WHERE country_3_code='".$user->country."' ORDER BY country_2_code ASC");
        $params = array(
            'website_id'      => OPAY_WEBSITE_ID,
            'order_nr'        => $db->f('order_id'),
            'redirect_url'    => SECUREURL.'index.php?option=com_virtuemart&page=checkout.opay_result',
            'web_service_url' => SECUREURL.'administrator/components/com_virtuemart/opay_notify.php',
            'standard'        => 'opay_8.1',
            'language'        => substr($jlang->getTag(), 0, 2),
            'amount'          => number_format($db->f('order_total'), 2, '', ''),
            'currency'        => $db->f('order_currency'),
            'country'         => $db1->f('country_2_code'),
            'c_email'         => $user->user_email,
        );

        $this->appendMetadataToParams($paramsArray);

        if (!empty($user->phone_1)) {
            $params['c_mobile_nr'] = $user->phone_1;
        } elseif (!empty($user->phone_2)) {
            $params['c_mobile_nr'] = $user->phone_2;
        }
        if (OPAY_TEST_MODE == 1) {
            $params['test'] = OPAY_USER_ID;
        }
        if (OPAY_SIGNATURE_TYPE == 1) {
            $opay->setSignaturePassword(OPAY_SIGNATURE_PASSWORD);
        } elseif (OPAY_SIGNATURE_TYPE == 2) {
            $opay->setMerchantRsaPrivateKey(OPAY_RSA_PRIVATE_KEY);
            $opay->setOpayCertificate(OPAY_OPAY_CERTIFICATE);
        }
        try {
            $params = $opay->signArrayOfParameters($params);
            $url = sprintf(
                    'https://gateway.opay.lt/pay/?encoded=%s',
                    $opay->convertArrayOfParametersToEncodedString($params)
            );
        } catch (Exception $e) {
            // TODO show error for the customer and log something
            vmRedirect(SECUREURL);
            return;
        }

        // Change Order status to OPAY pending status and add history comment
        $d = array(
            'current_order_status' => $db->f('order_status'),
            'order_id'             => $db->f('order_id'),
            'order_status'         => OPAY_STATUS_PENDING,
            'order_comment'        => $VM_LANG->_('PHPSHOP_OPAY_ORDER_HISTORY_COMMENT_PENDING'),
            'notify_customer'      => 'N',
        );
        $ps_order = new ps_order();
        $ps_order->order_status_update($d);

        header(sprintf('Location: %s', $url));
    }

    /**
     * OpayGateway class file must be included before calling this method.
     *
     * @return bool|int true on success, false on error, 2 if status code 2
     */
    function process_callback()
    {
        require_once(CLASSPATH.'opay'.DS.'opay_8.1.gateway.inc.php');

        $opay = new OpayGateway();
        if (OPAY_SIGNATURE_TYPE == 1) {
            $opay->setSignaturePassword(OPAY_SIGNATURE_PASSWORD);
        } elseif (OPAY_SIGNATURE_TYPE == 2) {
            $opay->setMerchantRsaPrivateKey(OPAY_RSA_PRIVATE_KEY);
            $opay->setOpayCertificate(OPAY_OPAY_CERTIFICATE);
        }

        $get = JRequest::get('GET');
        $post = JRequest::get('POST');

        if (isset($post['encoded'])) {
            $params = $opay->convertEncodedStringToArrayOfParameters($post['encoded']);
        } elseif (isset($get['encoded'])) {
            $params = $opay->convertEncodedStringToArrayOfParameters($get['encoded']);
        } elseif (isset($post['password_signature']) || isset($post['rsa_signature'])) {
            $params = $post;
        } elseif (isset($get['password_signature']) || isset($get['rsa_signature'])) {
            $params = $get;
        } else {
            return false; // Missing required request parameters
        }

        try {
            if (!$opay->verifySignature($params)) {
                return false; // Wrong signature
            }
        } catch (Exception $e) {
            return false;
        }

        $db = new ps_DB();
        $db->query('SELECT order_currency,order_total,order_status FROM #__{vm}_orders WHERE `order_id`='.$db->getEscaped($params['order_nr']));

        if ($db->f('order_status') != OPAY_STATUS_PENDING) {
            return true; // Order allready updated
        }
        if (number_format($db->f('order_total'), 2, '', '') != $params['amount']) {
            return false; // Order amount doesn't match
        }
        if (strcasecmp($db->f('order_currency'), $params['currency']) !== 0) {
            return false; // Order currency and paid currency doesn't match
        }

        global $VM_LANG;
        $VM_LANG->load('opay');

        switch ((int)$params['status']) {
            case 0:
                $d = array(
                    'current_order_status' => $db->f('order_status'),
                    'order_id'             => $params['order_nr'],
                    'order_status'         => OPAY_STATUS_CANCEL,
                    'order_comment'        => $VM_LANG->_('PHPSHOP_OPAY_ORDER_HISTORY_COMMENT_CANCEL'),
                    'notify_customer'      => 'N',
                );
                break;
            case 1:
                $channel = empty($params['p_bank']) ? $params['p_channel'] : $params['p_channel'].'_'.$params['p_bank'];
                $d = array(
                    'current_order_status' => $db->f('order_status'),
                    'order_id'             => $params['order_nr'],
                    'order_status'         => OPAY_STATUS_SUCCESS,
                    'order_comment'        => sprintf($VM_LANG->_('PHPSHOP_OPAY_ORDER_HISTORY_COMMENT_SUCCESS'), $channel),
                    'notify_customer'      => 'Y',
                );
                break;
            case 2:
                return 2;
            default:
                return false; // Unknown status code
        }

        $ps_order = new ps_order();
        $ps_order->order_status_update($d);

        return true;
    }

    private function appendMetadataToParams(&$paramsArray)
    {
        if (is_array($paramsArray) && array_key_exists('metadata', $paramsArray)) {
            unset($paramsArray['metadata']);
        }

        try {
            if (defined(VERSION)) {
                $paramsArray['metadata']['app_version'] = VERSION;
            }
        } catch (Exception $e) {
            // Do nothing to avoid any risks to break payment process
        }

        $paramsArray['metadata']['app_name'] = self::APP_NAME;
        $paramsArray['metadata']['widget_version'] = self::WIDGET_VERSION;
    }
}
